#ifndef _ROUTINES_CPP
#define _ROUTINES_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <CommCtrl.h>

#include "../../SharedSource/Debug.H"
#include "../../SharedSource/NSWFL.H"
#include "../../SharedSource/EventLog.H"

#include "../CSockSrvr/CSockSrvr.H"
#include "../../SharedClasses/SQLClass/cRecordSet.H"
#include "../../SharedClasses/SQLClass/cSQL.H"

#include "Entry.H"
#include "Init.H"
#include "WinService.H"
#include "Routines.H"
#include "Command.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

const char *gsWeekDayName[] = {
    "Sunday",
    "Monday",
    "Tuesday",
    "Wedensday",
    "Thursday",
    "Friday",
    "Saturday",
	NULL
};

bool gbWeekDays[7] = {0,1,1,1,1,1,0};

char gsSessionLogDir[MAX_PATH];
char sTempFilesPath[MAX_PATH];
char gsPath[MAX_PATH];
char gsServerAddress[255];

char gsAuthKey[MAX_AUTH_LENGTH];
char gsAuthString[MAX_AUTH_LENGTH];

char gsSQLDataFiles[MAX_PATH]; // Relative to server.
char gsDefaultDBO[255];
char gsReplicationDB[255];

char gsCompanyName[64];
char gsCompanyPassword[64];

char gsSQLDriver[255];
char gsSQLPassword[255];
char gsSQLServer[255];
char gsSQLUserID[255];

bool gbShowSplashScreen = false;
bool gbKillApplication = false;
bool gbApplicationRunning = false;
bool gbConnectNow = false;
bool gbRunningAsService = false;
bool gbDropBadPackets = false;
bool gbPacketMode = true;
bool gbAutoConnect = false;
bool gbCacheLogFile = false;

int giMaxClients = 1;
int giServerPort = 0;
int giPingTimeoutMS = 0;
int giTotalConnects = 0;
int giWarningCount = 0;
int giErrorCount = 0;
int giNextDay = -1;

DWORD gdwStartTime = 0;
DWORD gdwStopTime = 0;
DWORD gdwNextTime = 0;
DWORD gdwConnectInterval = 0;

DWORD Timer_Thread_ID = 0;

HANDLE Timer_Thread_Handle = NULL;

FILE *gfhSessionLog = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool GetRegistryValues(void)
{
	DWORD dwTemp = 0;
	DWORD iSizeofString = 0;
	int iLen = 0;

	iSizeofString = sizeof(gsReplicationDB);
	memset(gsReplicationDB, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ReplicationDB", gsReplicationDB, iSizeofString))
        return false;

	iSizeofString = sizeof(gsDefaultDBO);
	memset(gsDefaultDBO, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "DefaultDBO", gsDefaultDBO, iSizeofString))
        return false;

	iSizeofString = sizeof(gsSQLDataFiles);
	memset(gsSQLDataFiles, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLDataFiles", gsSQLDataFiles, iSizeofString))
        return false;

	iSizeofString = sizeof(gsSessionLogDir);
	memset(gsSessionLogDir, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SessionLogDir", gsSessionLogDir, iSizeofString))
        return false;
	
    iSizeofString = sizeof(gsServerAddress);
	memset(gsServerAddress, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ServerAddress", gsServerAddress, iSizeofString))
        return false;
	
    iSizeofString = sizeof(sTempFilesPath);
	memset(sTempFilesPath, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TempFilesPath", sTempFilesPath, iSizeofString))
        return false;
	
    iSizeofString = sizeof(gsPath);
	memset(gsPath, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "Path", gsPath, iSizeofString))
        return false;
	
	iSizeofString = sizeof(gsAuthKey);
	memset(gsAuthKey, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "AuthKey", gsAuthKey, iSizeofString))
        return false;
	
	iSizeofString = sizeof(gsAuthString);
	memset(gsAuthString, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "AuthString", gsAuthString, iSizeofString))
        return false;
	
	iSizeofString = sizeof(gsCompanyName);
	memset(gsCompanyName, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CompanyName", gsCompanyName, iSizeofString))
        return false;
	
	iSizeofString = sizeof(gsCompanyPassword);
	memset(gsCompanyPassword, 0, iSizeofString);
    if(!Get_BinaryRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CompanyPassword", gsCompanyPassword, iSizeofString))
        return false;
		
	iLen = iSizeofString;
	if(iLen > 0)
	{
		Decode(&gSC, gsCompanyPassword, gsCompanyPassword, iLen);
	}
	
	iSizeofString = sizeof(gsSQLDriver);
	memset(gsSQLDriver, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLDriver", gsSQLDriver, iSizeofString))
        return false;
		
	iSizeofString = sizeof(gsSQLPassword);
	memset(gsSQLPassword, 0, iSizeofString);
    if(!Get_BinaryRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLPassword", gsSQLPassword, iSizeofString))
        return false;

	iLen = iSizeofString;
	if(iLen > 0)
	{
		Decode(&gSC, gsSQLPassword, gsSQLPassword, iLen);
	}
		
	iSizeofString = sizeof(gsSQLServer);
	memset(gsSQLServer, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLServer", gsSQLServer, iSizeofString))
        return false;
		
	iSizeofString = sizeof(gsSQLUserID);
	memset(gsSQLUserID, 0, iSizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLUserID", gsSQLUserID, iSizeofString))
        return false;

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "PingTimeoutMS", dwTemp))
        return false;
	giPingTimeoutMS = (int) dwTemp;

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ConnectInterval", gdwConnectInterval))
        return false;
	
	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ServerPort", dwTemp))
        return false;
	giServerPort = (int) dwTemp;

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ShowSplashScreen", dwTemp))
        return false;
	gbShowSplashScreen = (dwTemp == 1);

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CacheLogFile", dwTemp))
        return false;
	gbCacheLogFile = (dwTemp == 1);

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TimeWindowBegin", gdwStartTime))
        return false;

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TimeWindowEnd", gdwStopTime))
        return false;

	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool SaveRegistryValues(void)
{
	char sLocalBuf[1024];
	int iBufSz = 0;
	DWORD dwTemp = 0;

	Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ReplicationDB", gsReplicationDB);
	Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "DefaultDBO", gsDefaultDBO);
	Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLDataFiles", gsSQLDataFiles);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SessionLogDir", gsSessionLogDir);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ServerAddress", gsServerAddress);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TempFilesPath", sTempFilesPath);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "Path", gsPath);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "AuthKey", gsAuthKey);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "AuthString", gsAuthString);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CompanyName", gsCompanyName);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLDriver", gsSQLDriver);

	iBufSz = strlen(gsCompanyPassword);
	dwTemp = (DWORD) iBufSz;
	Encode(&gSC, gsCompanyPassword, sLocalBuf, iBufSz);
	sLocalBuf[iBufSz] = '\0';
	Set_BinaryRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CompanyPassword", sLocalBuf, dwTemp);

	iBufSz = strlen(gsSQLPassword);
	dwTemp = (DWORD) iBufSz;
	Encode(&gSC, gsSQLPassword, sLocalBuf, iBufSz);
	sLocalBuf[iBufSz] = '\0';
	Set_BinaryRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLPassword", sLocalBuf, dwTemp);

	Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLServer", gsSQLServer);
    Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "SQLUserID", gsSQLUserID);
	
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "PingTimeoutMS", giPingTimeoutMS);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ConnectInterval", gdwConnectInterval);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ServerPort", giServerPort);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "ShowSplashScreen", gbShowSplashScreen);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "CacheLogFile", gbCacheLogFile);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TimeWindowEnd", gdwStopTime);
	Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TimeWindowBegin", gdwStartTime);


	return true;
}	

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool OpenLogFile(void)
{
    char FullFileName[MAX_PATH];

    SYSTEMTIME ST;

    GetLocalTime(&ST);

    char DateTemp[64 + 1];

    GetDateFormat(LOCALE_USER_DEFAULT, NULL, &ST, "MM-dd-yy", DateTemp,64);

    sprintf(FullFileName, "%s\\%s.txt", gsSessionLogDir, DateTemp);

    if( (gfhSessionLog = fopen(FullFileName, "ab")) == NULL)
        return false;

    return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CloseLogFile(void)
{
	if(gfhSessionLog)
	{
		fclose(gfhSessionLog);
		return true;
	}
	else return false;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteAnEvent(const char *sMessage, int iEventType)
{
	if(iEventType == EVENT_NONE)
	{
		//No need to record an event.
	}
	else if(iEventType == EVENT_INFO)
	{
		RecordInfo(sMessage);
	}
	else if(iEventType == EVENT_WARN)
	{
		RecordWarn(sMessage);
		giWarningCount++;
	}
	else if(iEventType == EVENT_ERROR)
	{
		RecordError(sMessage);
		giErrorCount++;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteSysLogEx(const char *sMessage, int iEventType)
{
    SYSTEMTIME ST;
    GetLocalTime(&ST);

    char lsDate[64];
    char lsTime[64];
	char lsTemp[MAX_STATUS_TEXT + (64 * 2) + 1];

    GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &ST, NULL, lsDate, 64);
    GetTimeFormat(LOCALE_USER_DEFAULT, 0, &ST, NULL, lsTime, 64);

	sprintf(lsTemp, "(%s %s) [*] %s", lsDate, lsTime, sMessage);
	fprintf(gfhSessionLog, "%s\r\n", lsTemp);

	if(!gbCacheLogFile)
	{
		fflush(gfhSessionLog);
	}
    
    InsertListBoxItem(MDI.LogList_hWnd, lsTemp, -1);

	WriteAnEvent(lsTemp, iEventType);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteSysLog(const char *sMessage)
{
	WriteSysLogEx(sMessage, EVENT_NONE);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteLogEx(int iClientId, const char *sMessage, int iEventType)
{
    SYSTEMTIME ST;
    GetLocalTime(&ST);

    char lsDate[64];
    char lsTime[64];
	char lsTemp[MAX_STATUS_TEXT + (64 * 2) + 1];

    GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &ST, NULL, lsDate, 64);
    GetTimeFormat(LOCALE_USER_DEFAULT, 0, &ST, NULL, lsTime, 64);

	sprintf(lsTemp, "(%s %s) [%d] %s", lsDate, lsTime, iClientId, sMessage);
	fprintf(gfhSessionLog, "%s\r\n", lsTemp);

	if(!gbCacheLogFile)
	{
		fflush(gfhSessionLog);
	}
    
    InsertListBoxItem(MDI.LogList_hWnd, lsTemp, -1);

	WriteAnEvent(lsTemp, iEventType);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteLog(int iClientId, const char *sMessage)
{
	WriteLogEx(iClientId, sMessage, EVENT_NONE);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool WaitOnApplicationToExit(void)
{
    gbKillApplication = true; // Tell application to exit

    if(gbIsMainDialogOpen)
    {
        EndDialog(MainDialog_hWnd, 0);
    }

    while(gbApplicationRunning) // Wait on application to exit
    {
        Sleep(1);
    }

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char *ResolveHost(char *xHostName, int AddressNum)
{
	char *IPAddress = NULL;
	struct hostent * Host;
	struct in_addr Address;
	Host = gethostbyname(xHostName);
	if(Host == NULL)return NULL;
	memcpy(&Address.s_addr,(*Host).h_addr_list[AddressNum],(*Host).h_length);
	IPAddress = inet_ntoa(Address);
	return IPAddress;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool GetIPAddress(char *InputAddr, char *OutAddr)
{
	bool ValidIP = true;

    if(inet_addr(InputAddr) == INADDR_NONE) ValidIP = false;
    if(strlen(InputAddr) < 7)               ValidIP = false;
    if(strlen(InputAddr) > 15)              ValidIP = false;

    
	if(ValidIP == false)
	{
		char *Resolved = ResolveHost(InputAddr, 0);
		if(Resolved == NULL)
		{
			return false;
		}
		strcpy(OutAddr, Resolved); 
	}
	else{
		strcpy(OutAddr, InputAddr); 
	}

	return true;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool IsAtleastOneDaySelected(void)
{
    int iDay = 0;

    while(iDay < 7)
    {
        if(gbWeekDays[iDay])
		{
            return true;
		}

        iDay++;
    }

    return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GetNextRunDay(int iToday)
{
    int iDay = iToday;
	
	if(!IsAtleastOneDaySelected())
	{
		return -1;
	}

	while(iDay < 7)
    {
        if(gbWeekDays[iDay])
		{
            return iDay;
		}

		if(iDay == 6)
		{
			iDay = 0;
		}

        iDay++;
    }

    return -1;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CalculateNextConnectTime(void)
{
	DWORD dwCurrentTime = 0;

	int iToday = 0;

	SYSTEMTIME ST;
	GetLocalTime(&ST);

	if(!IsAtleastOneDaySelected())
	{
		return;
	}

	iToday = ST.wDayOfWeek;

	giNextDay = GetNextRunDay(iToday);

	if(giNextDay != iToday)
	{
		gdwNextTime = gdwStartTime;
	}

	dwCurrentTime = TimeToLong(ST.wHour, ST.wMinute, ST.wSecond);

	//Keep incrementing next connect time until it is greater than the current time.
	while(gdwNextTime < dwCurrentTime)
	{
		gdwNextTime = (gdwNextTime + (gdwConnectInterval * 60));
	}

	/*
	//Is the new 'next connect time' outside the window?
	if(dwCurrentTime <= gdwStartTime || dwCurrentTime >= gdwStopTime)
	{
		gdwNextTime = gdwStartTime;
		
		giNextDay = GetNextRunDay(giNextDay + 1);
	}
	*/

	//Is the new 'next connect time' outside the window?
	if(dwCurrentTime >= gdwStopTime)
	{
		gdwNextTime = gdwStartTime;
		
		giNextDay = GetNextRunDay(giNextDay + 1);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void PrintNextRunTime(void)
{
    int iHour, iMinute, iSecond;

	SYSTEMTIME ST;
	char sNextTime[64];
	char sMessage[255];

	GetLocalTime(&ST);

	LongToTime(gdwNextTime, &iHour, &iMinute, &iSecond);

	ST.wHour   = iHour;
    ST.wMinute = iMinute;
    ST.wSecond = iSecond;

	GetTimeFormat(LOCALE_USER_DEFAULT, 0, &ST, NULL, sNextTime, 64);

	sprintf(sMessage, "Next transfer will occur at %s @ %s", gsWeekDayName[giNextDay], sNextTime);
	WriteSysLogEx(sMessage, EVENT_NONE);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI Timer_Thread(LPVOID data)
{
	DWORD dwCurrentTime = 0;
	DWORD dwStatusTime = 0;
	SYSTEMTIME ST;

	//gdwStartTime = TimeToLong(9, 0, 0);
	//gdwStopTime = TimeToLong(17, 0, 0);

	//gdwConnectInterval = 5;

	//GetSystemTime(&ST);
	GetLocalTime(&ST);

	dwCurrentTime = TimeToLong(ST.wHour, ST.wMinute, ST.wSecond);

	//Set the next connect time to the beginning of the time window.
	gdwNextTime = gdwStartTime;

	CalculateNextConnectTime();

	while(!gbKillApplication)
	{
		//GetSystemTime(&ST);
		GetLocalTime(&ST);

		if(ST.wDayOfWeek == giNextDay || gbConnectNow)
		{
			dwCurrentTime = TimeToLong(ST.wHour, ST.wMinute, ST.wSecond);

			//Are we within the time window?
			if((dwCurrentTime >= gdwStartTime && dwCurrentTime <= gdwStopTime) || gbConnectNow)
			{
				//Is it time to connect?
				if(dwCurrentTime >= gdwNextTime || gbConnectNow)
				{
					if(gbRunningAsService || gbConnectNow)
					{
						if(ConnectToServer(gbConnectNow))
						{
							while(gServer.bcConnected[CCI.iThisClient])
							{
								Sleep(1);
							}
							Sleep(1000);
						}
					}
					else{
						WriteSysLogEx("The SQL-Exchange client is not running as a service. Auto-Connection will not occur.", EVENT_WARN);
					}

					if(!gbConnectNow)
					{
						gdwNextTime = (gdwNextTime + (gdwConnectInterval * 60));
					}

					gbConnectNow = false;
				}
			}
			else gdwNextTime = gdwStartTime;
		}

		CalculateNextConnectTime();

		//If the 'next connect time' has changed, log it.
		if(dwStatusTime != gdwNextTime)
		{
			PrintNextRunTime();
			dwStatusTime = gdwNextTime;
		}

		Sleep(1000);
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CmdCmp(const char *sBuf, const char *sCmd)
{
	int iCmdLen = strlen(sCmd);
	if( strncmp(sBuf, sCmd, iCmdLen) == 0)
		return iCmdLen;
	else return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int AppendDataToCmd(const char *sCmd, char *sData, int iDataSz, char *sOutBuf)
{
	int iRPos = 0;
	int iRWos = strlen(sCmd);

	strcpy(sOutBuf, sCmd);

	while(iRPos < iDataSz)
		sOutBuf[iRWos++] = sData[iRPos++];

	return iRWos;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int BreakCmdFromData(const char *sBuf, int iCmdLen, int iBufSz, char *sOutBuf)
{
	int WPos = 0;
	int RPos = iCmdLen;

	while(RPos < iBufSz)
		sOutBuf[WPos++] = sBuf[RPos++];

	sOutBuf[WPos] = '\0';

	return WPos;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//This function will set the row, column text of a list view.
void SetStatus(HWND Grid_hWnd, int iCol, int iItem, char *sText)
{
	LV_ITEM MyLVItem;

	memset(&MyLVItem, 0, sizeof(MyLVItem));

	MyLVItem.pszText  = sText;
	MyLVItem.mask     = LVIF_TEXT;
	MyLVItem.iSubItem = iCol;
	MyLVItem.iItem    = iItem;

	ListView_EnsureVisible(Grid_hWnd, iItem, FALSE);
	ListView_SetItem(Grid_hWnd, &MyLVItem);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
